<template>
  <a-modal
    :title="modalTitle"
    :width="800"
    :visible="visible"
    :confirmLoading="confirmLoading"
    @cancel="handleCancel"
  >
    <a-form :form="form">

      <a-form-item v-show="false" >
        <a-input v-decorator="['id']" type="hidden"/>
      </a-form-item>

      <a-form-item
        label="退库单id"
        :labelCol="BaseTool.Constant.labelCol"
        :wrapperCol="BaseTool.Constant.wrapperCol"
        v-show="false"
      >
        <a-input
          v-decorator="['pickId', {rules: [{required: true, message: '退库单id不能为空'}]}]" />
      </a-form-item>
      <a-form-item
        label="退库单号"
        :labelCol="BaseTool.Constant.labelCol"
        :wrapperCol="BaseTool.Constant.wrapperCol"
      >
        <a-input
          disabled
          style="width:70%; margin-right:10px"
          v-decorator="['pickNo', {rules: [{required: true, message: '退库单号不能为空'}]}]" />
        <a-button type="primary" @click="handleSpareFormSelect">选择退库单</a-button>
      </a-form-item>
      <a-form-item
        label="备件id"
        :labelCol="BaseTool.Constant.labelCol"
        :wrapperCol="BaseTool.Constant.wrapperCol"
        v-show="false"
      >
        <a-input
          v-decorator="['spareId', {rules: [{required: true, message: '备件id不能为空'}]}]" />
      </a-form-item>
      <a-form-item
        label="备件名称"
        :labelCol="BaseTool.Constant.labelCol"
        :wrapperCol="BaseTool.Constant.wrapperCol"
      >
        <a-input
          disabled
          style="width:70%;margin-right:5px"
          v-decorator="['spareName', {rules: [{required: true, message: '备件名称不能为空'}]}]" />
        <a-button type="primary" @click="handleSpareSelect">选择备件</a-button>
      </a-form-item>
      <a-form-item
        label="退库数量"
        :labelCol="BaseTool.Constant.labelCol"
        :wrapperCol="BaseTool.Constant.wrapperCol"
      >
        <a-input-number
          style="width: 100%"
          :min="1"
          v-decorator="['num', {initialValue:1,rules: [{required: true, message: '退库数量不能为空'}]}]" />
      </a-form-item>
    </a-form>
    <template slot="footer">
      <a-button :loading="confirmLoading" type="primary" @click="save()">保存</a-button>
    </template>
    <spare-part-info-select-modal ref="spareSelectModal" @selected="handleSpareSelected"/>
    <spare-back-form-select-modal ref="spareBackFormSelectModal" @selected="handleSpareFormSelected"/>
  </a-modal>
</template>

<script>
import pick from 'lodash.pick'
import { addSparePickDetail, updateSparePickDetail } from '@/api/store/sparebackdetail'
import SparePartInfoSelectModal from '@/views/sqarepartmanage/sparepartinfo/modules/SparePartInfoSelectModal'
import SpareBackFormSelectModal from '@/views/store/sparebackform/modules/SpareBackFormSelectModal'
export default {
  name: 'BaseSpareBackDetail',
  data () {
    return {
      confirmLoading: false,
      modalTitle: null,
      form: this.$form.createForm(this),
      visible: false
      // 下拉框map
    }
  },
  components: {
    SparePartInfoSelectModal,
    SpareBackFormSelectModal
  },
  props: {
  },
  created () {
    // 下拉框map
  },
  methods: {
    base (record) {
      this.visible = true
      // 如果是空标识添加
      if (this.BaseTool.Object.isBlank(record)) {
        this.modalTitle = '添加'
        return
      }
      this.modalTitle = '编辑'
      const { form: { setFieldsValue } } = this
      // 日期处理
      this.$nextTick(() => {
        setFieldsValue(Object.assign(pick(record, [
          'id',
          'pickId',
          'pickNo',
          'spareId',
          'spareName',
          'num'
        ])))
      })
    },
    save () {
      const { form: { validateFieldsAndScroll } } = this
      this.confirmLoading = true
      validateFieldsAndScroll((errors, values) => {
        if (errors) {
          this.confirmLoading = false
          return
        }
        // 日期处理
        if (this.BaseTool.String.isBlank(values.id)) {
          addSparePickDetail(values)
            .then(() => {
              this.handleCancel(values)
            }).catch(() => {
              this.confirmLoading = false
            })
        } else {
          updateSparePickDetail(values)
            .then(() => {
              this.handleCancel(values)
            }).catch(() => {
              this.confirmLoading = false
            })
        }
      })
    },
    handleCancel (values) {
      this.visible = false
      this.confirmLoading = false
      this.form.resetFields()
      if (this.BaseTool.Object.isNotBlank(values)) {
        this.$emit('ok', values)
      }
    },
    handleSpareSelect () {
      this.$refs.spareSelectModal.base()
    },
    handleSpareSelected (record, keys, rows) {
      const [ key ] = keys
      const [ row ] = rows
      const { form: { setFieldsValue } } = this
      // 日期处理
      this.$nextTick(() => {
        setFieldsValue(Object.assign({
          'spareId': key,
          'spareName': row.name
        }))
      })
    },
    handleSpareFormSelect () {
      this.$refs.spareBackFormSelectModal.base()
    },
    handleSpareFormSelected (record, keys, rows) {
      const [ key ] = keys
      const [ row ] = rows
      console.log(row, 222)
      const { form: { setFieldsValue } } = this
      // 日期处理
      this.$nextTick(() => {
        setFieldsValue(Object.assign({
          'pickId': key,
          'pickNo': row.pickNo
        }))
      })
    }

  }
}
</script>
